package model;

import java.awt.List;
import java.io.*;
import java.net.* ;
import view.*;
/**
 * 
 * @author SELVAGGIO GIANLCUA
 * @version 1.0
 * MAIN AGENT FOR SEARCH WITH CODE PART ADN PARTIAL DESCRIPTION  
 */
public class AgentFind extends Thread{
	
		private Buffer buffer;
		private URL url;
		private String inputLine,sequence,description,subString,codName;
		private BufferedReader in;
		private boolean state;
		private int first,last;
		private List list;
		private ResultPage result;
		private AgentSupport[] agent1;
		
		
		public AgentFind(Buffer b){
			buffer=b;
			state=false;
			list=new List();
			agent1=new AgentSupport[11];
		}
			
		public void run(){
			// TODO Auto-generated method stub
			while(true){
				if(state){
					if(!buffer.getCodPart().isEmpty()){
						this.connect1(buffer.getCodPart());
						this.deactive();
					}
					if(!buffer.getDescription().isEmpty()){
						this.connect2(buffer.getDescription());
						result=new ResultPage(list,this,false);
						if(state){
							result.setVisible(true);
						}
						this.deactive();
						
						
					}
					if(!buffer.getSequence().isEmpty()){
						for(int w=0;w<agent1.length;w++){
							if(buffer.getTypePart()[w]!=null){
								agent1[w]=new AgentSupport(buffer,this,w);
								agent1[w].start();
								agent1[w].activeSupport();
							}
						}
						this.deactive();
						
					}
				}else{
					standby();
				}
			}
		}
	

		
		/**
		 * SEARCH BY REGISTRY CODE
		 */
		public void connect1(String str){
			//looking by registry code
			try {
				list.removeAll();
				url = new URL("http://partsregistry.org/wiki/index.php?title=Part:"+str);
				in = new BufferedReader(new InputStreamReader(url.openStream()));
				while ((inputLine = in.readLine()) != null){
				   first=inputLine.indexOf("var sequence = new String('");
				   last=inputLine.indexOf("');");
				   if(first>0&&last>0){
						 sequence=inputLine.substring(first+27,last);
				   }
				   first=inputLine.indexOf("font-weight: bold;'>");
				   last=inputLine.indexOf("</SPAN>");
				   if(first>0&&last>0){
						 description=inputLine.substring(first+20,last);
				   }
				}
				buffer.setCodPart(str);
				buffer.setDescription(description);
				buffer.setSequence(sequence);
				in.close();
				} catch (MalformedURLException e) {
					// TODO Auto-generated catch block
					e.printStackTrace();
				} catch (IOException e) {
					// TODO Auto-generated catch block
					e.printStackTrace();
					
			}
			description="";
			sequence="";
		}
			
		/**
		 * SEARCH BY PARTIAL DESCRIPTION
		 */
		public void connect2(String str){
			
				try {
					list.removeAll();
					description=str;
					int i=0;
					while(buffer.getTypePart()[i]!=null&&i<buffer.getTypePart().length-1&&state){
						url = new URL("http://partsregistry.org/cgi/partsdb/pgroup.cgi?pgroup="+buffer.getTypePart()[i]);
						in = new BufferedReader(new InputStreamReader(url.openStream()));
						while ((inputLine = in.readLine()) != null&&state){
							if(inputLine.indexOf("index.php?title=Part:")>0 && inputLine.indexOf("'>BBa_")>0){
								first=inputLine.indexOf("index.php?title=Part:");
								last=inputLine.indexOf("'>BBa_");
							    codName=inputLine.substring(first+21,last);
							}
							if(pageType(buffer.getTypePart()[i])==1&&state){
								if(inputLine.indexOf("</A></TD><TD>")>0&&state){
								first=inputLine.indexOf("</A></TD><TD>");
								subString=inputLine.substring(first+13,inputLine.length()-1);
								if(subString.indexOf("</TD><TD>")>0&&state);
									first=subString.indexOf("</TD><TD>");
									subString=subString.substring(first+9,subString.length()-1);
									if(subString.indexOf("</TD><TD>")>0&&state){
										last=subString.indexOf("</TD><TD>");
										String target=subString.substring(0,last);
										target=target.toLowerCase();
										description=description.toLowerCase();
										if(target.indexOf(description)>0&&state){
											list.add(codName);
											list.add(subString.substring(0,last));
										}
									}
								}
							}else{
								if(inputLine.indexOf("</A></TD><TD>")>0&&state){
									first=inputLine.indexOf("</A></TD><TD>");
									subString=inputLine.substring(first+13,inputLine.length()-1);
									if(subString.indexOf("<")>0&&state){
										last=subString.indexOf("<");
										String target=subString.substring(0,last);
										target=target.toLowerCase();
										description=description.toLowerCase();
										if(target.indexOf(description)>=0&&state){
											list.add(codName);
											list.add(target);
										}
									
								    }
								}
							}
						}
						in.close();
						subString="";
						i++;
					}
					
					
				
				} catch (MalformedURLException e) {
					// TODO Auto-generated catch block
					e.printStackTrace();
				} catch (IOException e) {
					// TODO Auto-generated catch block
					e.printStackTrace();
				}
				
		}
		
		/**
		 * SHOW THE MATCH SUBSTRING OF THE SEQUENCE CHANGE ITS CASE
		 */
		public void showMatch(String seq,String targ){
			
			buffer.setSequence(seq.replaceAll(targ,targ.toUpperCase()));
		}
			
		/**
		 * CHANGE TEH SEARCH PARAMETERS IN FUNCTION OF THE TYPE OF PAGE
		 */
		private int pageType(String str){
			int select=0;
			if(str=="Measurement"||str=="generator"||str=="composite"||str=="rna"||str=="dna"||str=="conjugation"){
					select=1;
				}else{
					select=2;
				}
			return select;
		}
		
		/**
		 * SLEEP THE FIND AGENT THREAD
		 */
		private void standby(){
			
			try {
					sleep(100);
				} catch (InterruptedException e) {
					// TODO Auto-generated catch block
					e.printStackTrace();
				}
		}
						
	
		/**
		 * ACTIVE THE FIND AGENT
		 */
		public synchronized void active() {
			this.setPriority(MAX_PRIORITY);
			this.notifyAll();
			this.setPriority(NORM_PRIORITY);
			
		}
		/**
		 * STOP ALL THE SUPPORT AGENT
		 */
		public void deleteSupport(){
			
			for(int i=0;i<agent1.length;i++){
				agent1[i].stop();
			}
			
		}
		/**
		 * RETURN THE AGENT FIND STATE'S
		 */
		public boolean getstate(){
			
			return state;
		}
		/**
		 * SET THE AGENT FIND STATE'S
		 */
		public void setstate(boolean a){
			
			state=a;
		}
		/**
		 * STOP THE FIND AGENT ACTIVITIES
		 */
		public synchronized void deactive(){
			
			state=false;
			try {
				this.wait();
			} catch (InterruptedException e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
			}
		}
}