package model;

import java.awt.List;
import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStreamReader;
import java.net.MalformedURLException;
import java.net.URL;

import view.ResultPage;
/**
 * 
 * @author SELVAGGIO GIANLUCA
 * @version 1.0
 * SUPPORT AGENT FOR MULTIPLE SEQUENCE SEARCH
 */
public class AgentSupport extends Thread{
	
	
	private Buffer buffer;
	private URL url;
	private String inputLine,sequence,target,description;
	private BufferedReader in;
	private int first,last,k;
	private List list,resultlist;
	private AgentFind agent;
	private boolean state;
	
	
	public AgentSupport(Buffer b,AgentFind a,int w){
		buffer=b;
		agent=a;
		k=w;
		sequence="h";
		target="w";
		description="";
		list=new List();
		state=false;
		resultlist=new List();
	}
		
	

	public void run(){
		while(true){
			if(state){
				this.setName(buffer.getTypePart()[k]);
				support(buffer.getTypePart()[k],agent);
			}else{
				clearAgent();
				standbySupport();
				
			}
		}
	}
	/**
	 * SEARCH ALL THE MATCH WITH THE QUERY SEQUENCE IN THE REGISTRY
	 */
	public void support(String str,AgentFind a){
		try {
			list.removeAll();
			url = new URL("http://partsregistry.org/cgi/partsdb/pgroup.cgi?pgroup="+str);
			in = new BufferedReader(new InputStreamReader(url.openStream()));
			while ((inputLine = in.readLine()) != null){
				first=inputLine.indexOf("index.php?title=Part:");
				last=inputLine.indexOf("'>BBa_");
				if(first>0 && last>0){
					list.add(inputLine.substring(first+21,last));
				}
			}
			in.close();
			for(int j=0;j<list.getItemCount()-1;j++){
					url = new URL("http://partsregistry.org/wiki/index.php?title=Part:"+list.getItem(j));
					in = new BufferedReader(new InputStreamReader(url.openStream()));
					while ((inputLine = in.readLine()) != null){
						first=inputLine.indexOf(" bold;'>");
						if(first>0){
							description=inputLine.substring(first+8,inputLine.length());
							if(description.indexOf("</SPAN")>0){
								last=description.indexOf("</SPAN");
								description=description.substring(0,last);
							}
						}
						if(inputLine.indexOf("var sequence = new String('")>0){
							first=inputLine.indexOf("var sequence = new String('");
							last=inputLine.indexOf("'); ");
							sequence=inputLine.substring(first+27,last);
							target=buffer.getSequence();
							if(sequence.indexOf(target)>=0){
								first=sequence.indexOf(target);
								last=first+target.length();
								resultlist.add(list.getItem(j));
								resultlist.add(description);
								resultlist.add(sequence);
								resultlist.add(target);
								resultlist.add(""+first);
								resultlist.add(""+last);
								resultlist.add(str);
								}
							}
						}
						sequence="h";
						target="w";
						description="";
						
					}
					in.close();	
				buffer.showResult(resultlist,agent);
				this.clearAgent();
				this.deactiveSupport();
		} catch (MalformedURLException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		} catch (IOException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
	}

	/**
	 * CLEAR THE AGENT SUPPORT FIELD
	 */
	public void clearAgent(){
	
		sequence="h";
		list.removeAll();
		target="w";
		description="";
	}
	/**
	 * ACTIVE AGENT SUPPORT
	 */
	public synchronized void activeSupport(){
		state=true;
		this.setPriority(MAX_PRIORITY);
		this.notifyAll();
		if(buffer.getTypePart()[k].equalsIgnoreCase("measurement")||buffer.getTypePart()[k].equalsIgnoreCase("regulatory")){
			this.setPriority(MAX_PRIORITY);
		}else{
			this.setPriority(NORM_PRIORITY);
		}
		
		
	}
	/**
	 * STOP THE AGENT SUPPORT ACTIVITIES
	 */
	public synchronized void deactiveSupport(){
		
		state=false;
		this.setPriority(MIN_PRIORITY);
		if(!this.isInterrupted()){
			try {
				this.wait();
			} catch (InterruptedException e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
			}
		}
	}
		
	/**
	 * SLEEP THE AGENT SUPPORT THREAD
	 */
	private void standbySupport(){
		
		try {
			sleep(100);
		} catch (InterruptedException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
	}
}
