package model;
import java.awt.List;
import java.util.*;
import control.FindEventListener;

import view.*;
/**
 * 
 * @author SELVAGGIO GIANLUCA
 * @version 1.0
 * BUFFER CLASS FOR THE AGENT
 */
public class Buffer {
	
	private String codPart,description,sequence;
	private String[] typePart;
	private SearchPage search;
	private ArrayList listeners;
	private List list,resultList;
	private int contThread,limit;
	private AgentFind agent;
	private ResultPage resultPage;
	
	
	public Buffer(){
		listeners=new ArrayList();
		contThread=0;
		resultList=new List();
	}
	
	/**
	 * ACHIEVE THE DATA FROM THE GUI
	 */
	public void load(SearchPage s){
		
		codPart=s.returnCodPart();
		description=s.returnDescription();
		typePart=s.returnTypePart();
		sequence=s.returnSequence();
	}
		
	/**
	 * RESET AL THE FIELD OF THE BUFFER CLASS
	 */
	public void clearBuffer(){
		
		codPart=null;
		description=null;
		typePart=null;
		sequence=null;
		contThread=0;
	}
	/**
	 * SET THE CODE PARTS FIELD OF THE GUI WITH THE STRING ST
	 */
	synchronized public void setCodPart(String st){
		
		codPart=st;
		notifyEvent(new FindEvent(codPart,"codPart"));
	}
	/**
	 * SET THE PARTIAL DESCRIPTION FILD OF THE GUI WITH THE STRING ST
	 */
	synchronized public void setDescription(String st){
		
		description=st;
		notifyEvent(new FindEvent(description,"description"));
		
	}
	/**
	 * SET THE SEQUENCE FIELD OF THE GUI WITH THE STRING ST
	 */
	synchronized public void setSequence(String st){
		
		sequence=st;
		notifyEvent(new FindEvent(sequence,"sequence"));
		
	}
	/**
	 * RETURN THE RESEARCH RESULT LIST
	 */
	synchronized public List getResultList(){
		
		return list;
	}
	/**
	 * RETURN THE FIELD CODE PART
	 */
	synchronized public String getCodPart(){
		
		return codPart;
	}
	/**
	 * RETURN THE FIELD DESCRIPTION
	 */
	synchronized public String getDescription(){
		
		return description;
	}
	/**
	 * RETURN THE FIELD TYPE PART
	 */
	synchronized public String[] getTypePart(){
		
		return typePart;
	}
	/**
	 * RETURN THE FIELD SEQUENCE
	 */
	synchronized public String getSequence(){
		
		return sequence;
	}
	/**
	 * CREATE THE RESULT PAGE GUI AND POPULATE IT WITH THE RESEARCH RESULT
	 */
	synchronized public void showResult(List lis,AgentFind a){
		
		agent=a;
		for(int i=0;i<lis.getItemCount();i++){
			resultList.add(lis.getItem(i));
		}
		if(contThread>this.countType()-1){
			resultPage=new ResultPage(resultList,agent,true);
			resultPage.setVisible(true);
		}
		contThread++;
		
	}
	/**
	 * COUNT THE TYPE PART SELECTED
	 */
	private int countType(){
		
		limit=0;
		for(int i=0;i<this.getTypePart().length-1;i++){
			if(this.getTypePart()[i]!=null){
				limit++;
			}
		}
		return	limit;
		
	}
	
	private void notifyEvent(FindEvent ev) {
		
		// TODO Auto-generated method stub
		Iterator it=listeners.iterator();
		while(it.hasNext()){
			((FindEventListener)it.next()).findString(ev);
		}
		
	}
	public void  addListener(FindEventListener l){
		listeners.add(l);
	}
	
}
